/*
    Jack Raats
    Noorddonk 107
    4651 ZD Steenbergen
    01670 - 65298
    Email:  2:285/751@fidonet.org
           27:1331/304@SIGnet.org

    30 december 1992     DeSmet C / C68 v3.05
*/

/* modded by morris
*/

#include <stdio.h>
#include <stdlib.h>

char *tabel[] =
{
    " ","{1}","{2}","{7}","{4}",
    "{5}","{T}","{E}","{A}","{D}",
    "{S}","\"","#","$",":",
    "?","(",")",">","<",
    "=","+","-","*","/",
    ";",",",".","0","1",
    "2","3","4","5","6",
    "7","8","9","A","B",
    "C","D","E","F","G",
    "H","I","J","K","L",
    "M","N","O","P","Q",
    "R","S","T","U","V",
    "W","X","Y","Z","RND",
    "INKEY$","PI","CALL ","ERR MSGS ","DPOKE ",
    "ERROR ","CHAR "," ","TRACE ","DRAW ",
    "UNDRAW ","PROTECT ","EDIT ","AUTO ","DEF PROC ",
    "END PROC ","","DELETE ","DO ","LOOP ",
    "EXIT ","UNTIL ","WHILE ","WHEN ","INDENT ",
    "RESEQ ","OFF","CURSOR ","DATA ","RESTORE ",
    "READ ","NOSTALGIC ","USER ","*","ON",
    "HOME ","BREAK ","DPEEK ","LINE ","POP ",
    "PUSH ","CLR STACK ","DUP ","ELSE ","END WHEN ",
    "?","?","?","?","?",
    "?","?","?","?","?",
    "?","?","?","?","?",
    "?","?","?","[ ]","{Q}",
    "{W}","{6}","{R}","{8}","{Y}",
    "{E}","{H}","{G}","{F}","[\"]",
    "[#]","[$]","[:]","[?]","[(]",
    "[)]","[>]","[<]","[=]","[+]",
    "[-]","[*]","[/]","[;]","[,]",
    "[.]","[0]","[1]","[2]","[3]",
    "[4]","[5]","[6]","[7]","[8]",
    "[9]","[A]","[B]","[C]","[D]",
    "[E]","[F]","[G]","[H]","[I]",
    "[J]","[K]","[L]","[M]","[N]",
    "[O]","[P]","[Q]","[R]","[S]",
    "[T]","[U]","[V]","[W]","[X]",
    "[Y]","[Z]","\"\"","AT ","TAB ",
    "?","CODE ","VAL ","LEN ","SIN ",
    "COS ","TAN ","ASN ","ACS ","ATN ",
    "LN ","EXP ","INT ","SQR ","SGN ",
    "ABS ","PEEK ","USR ","STR$ ","CHR$ ",
    "NOT ","**"," OR "," AND ","<=",
    ">=","<>"," THEN "," TO "," STEP ",
    "LPRINT ","LLIST ","STOP ","SLOW ","FAST ",
    "NEW ","SCROLL ","CONT ","DIM ","REM ",
    "FOR ","GOTO ","GOSUB ","INPUT ","LOAD ",
    "LIST ","LET ","PAUSE ","NEXT ","POKE ",
    "PRINT ","PLOT ","RUN ","SAVE ","RAND ",
    "IF ","CLS ","UNPLOT ","CLEAR ","RETURN ",
    "COPY "
};

unsigned char buffer [128];
int  a,
     b,
     c,
     teller,
     lengte,
     count,
     dfile,
     regel;

FILE *fi, 
     *fo;

int dpeek ( int positie )
{
    a = buffer [positie];
    b = buffer [positie+1];
    return ( a + 256 * b );
}

int newline ( int linenumer)
{
    fread ( buffer, 1, 4, fi );
    regel = 256 * buffer[0] + buffer[1];

   if (linenumer == regel)
   {
      return 1;
   }

    lengte = dpeek ( 2 );
    if ( teller >= dfile ) return 0;

    printf ( "\n%04x %4d ", teller, regel );
    count = 0;
    teller += 4;
    return 0;
}

int fout ( )
{
    printf ("\n\n");
    fflush ( stdout );
    return 0;
}

int writeautostart(int addr)
{
   char buffer[64*1024];
   printf("\n Found. Writing autostart address in P file...");

   rewind(fi);
   size_t size = fread(buffer, 1, 65535, fi);
   buffer[32] = addr & 255;
   buffer[33] = addr / 256;

   rewind(fi);
   fwrite(buffer, 1, size, fi);
   fclose(fi);

   printf("\n Done!\n\n");

   return 0;
}

int main ( int argc, char** argv )
{
    printf ( "\nZX81 P-file AutoRun utility by SirMorris, Based on:");
    printf ( "\n     list utility (C) Jack Raats, Steenbergen 1992");

    if ( argc != 3 )
    {
        printf ("\n\n   USAGE:");
        printf ("\n\n   PAR filename.p linenumber");
        return fout();
    }

    if ( ! ( fi = fopen ( argv[1], "rb+" ) ) ) 
    {
        printf ("\n\n   Cannot open %s", argv[1] );
        return fout();
    }

    int linrnumber = atoi(argv[2]);

    printf("\n   Attempting to find line %d...", linrnumber);

    fread ( buffer, 1, (16509-16393), fi );

    dfile = dpeek ( 3 );
    teller = 16509;

    if (newline(linrnumber) == 1)
    {
      // got it..
      return writeautostart(teller);
    }

    while ( teller < dfile )
    {
        c = fgetc ( fi );
        teller++;
        count++;
        switch (c)
        {
            case 118:
                if ( count != lengte )
                {
                    b = lengte - count;
                    for ( a = 1 ; a <= b ; a ++ )
                        c = fgetc ( fi );
                    teller += b;
                }

                if (newline(linrnumber) == 1)
                {
                  // got it..
                  return writeautostart(teller);
                }

                break;
            case 126:
                fread ( buffer, 1, 5, fi );
                teller += 5;
                count += 5;
                break;
            default:
                printf ( "%s", tabel[c] );
                break;
        }
    }
    printf ( "\n\n----- END OF LISTING -----\n");
    fclose ( fi );

    printf ("\n\n   Requested line number not found.\n\n");
}
